#include <stdio.h>
#include <stdlib.h>
#include "code.h"

#define DEFAULT_SCALE 5-1
#define MAXMUSICLENG 1024
#define AUTOENTER
#ifdef AUTOENTER
#define BEATPART 4    //<<<<<<<<<<<<<<<<
#define BEATLENG BEATPART*MAXBEAT
#endif

FILE *headin,*bodyin,*fout;
unsigned int Music[MAXMUSICLENG][2];
int n/*,beat,maxbeat,note*/,scale,Tup;//- 4 8 12(8th:4)

int display();
int input();
int Ninput();
int output();

int main(){
	char key;
	int i;
	//ʼ 
	headin=fopen(HEADCODEFILE,"r");
	if(headin==NULL){
		printf("Cannot read \"%c\"",HEADCODEFILE);
		getch();
		return 0;
	}
	bodyin=fopen(BODYCODEFILE,"r");
	if(bodyin==NULL){
		printf("Cannot read \"%c\"",BODYCODEFILE);
		getch();
		return 0;
	}
	fout=fopen(OUTFILE,"w+");
	if(fout==NULL){
		printf("Cannot write&read \"%c\"",OUTFILE);
		getch();
		return 0;
	}
	n=0;
	Music[0][0]=Music[0][1]=0;
	/*beat=4;maxbeat=4;note=0;*/scale=DEFAULT_SCALE,Tup=0;
	// 
	while(1){
		display();
		input();
	}
	_fcloseall();
	return 0;
}

int display(){
	int i,t3;char nc,count=0;
	system("cls");
	for(i=0;i<n;i++){
		if(Music[i][0]==0xFF){
			nc='O';t3=0;
		}else{
			switch(Music[i][0]%12){
				case 0:
					nc='A';t3=0;
					break;
				case 1:
					nc='A';t3=1;
					break;
				case 2:
					nc='B';t3=0;
					break;
				case 3:
					nc='C';t3=0;
					break;
				case 4:
					nc='C';t3=1;
					break;
				case 5:
					nc='D';t3=0;
					break;
				case 6:
					nc='D';t3=1;
					break;
				case 7:
					nc='E';t3=0;
					break;
				case 8:
					nc='F';t3=0;
					break;
				case 9:
					nc='F';t3=1;
					break;
				case 10:
					nc='G';t3=0;
					break;
				case 11:
					nc='G';t3=1;
					break;
			}
		}
		printf("%c%c%c_%3d ",t3==1?'#':' ',nc=='O'?' ':Music[i][0]/12+1+'0',nc,Music[i][1]);
#ifdef AUTOENTER
		count+=Music[i][1];
		while((int)(count/BEATLENG)>=1){
			putchar('\n');
			count-=BEATLENG;
		}
#endif
	}
	printf("\n");
	printf("%d/%d Ŀǰ: %d/8;Ƿ:%s\n",BEATPART,MAXBEAT,scale+1,Tup==1?"":"");
	return 0;
}

int input(){
	unsigned char note;
	int beat;
	printf("C : ");
	scanf("%c",&note);
	if(note=='.'){
		scanf("%c",&note);
		switch(note){
			case 'C':
			case 'c':
				n=0;
				Music[0][0]=0;
				Music[0][1]=0;
				break;
			case 'E':
			case 'e':
				_fcloseall();
				exit(0);
				break;
			case 'H':
			case 'h':
				printf("ʽ: д ---- <Note><Beat>\n");
				printf("               Χ Note A~G,S(ֹ)      (ִСд)\n");
				printf("                    Beat >=1 & <=255\n");
				printf("               eg.{ A2                 ---- 2/%dĵA\n",MAXBEAT);
				printf("               }\n");
				putchar('\n');
				printf("      ı ---- 1~8                     (Ϊ8ʱ,ֻA~C\n");
				putchar('\n');
				printf("       ---- #\n");
				putchar('\n');
				printf("           ---- .<command>              (ִСд)\n");
				printf("               eg.{ .C                 ---- ȫ\n");
				printf("                    .E                 ---- ˳\n");
				printf("                    .H                 ---- \n");
				printf("                    .N                 ---- (ʽ: -12+#12.)\n");
				printf("                    .O                 ---- Դ\n");
				printf("                    .Z                 ---- ɾһ\n");
				printf("               }\n");
				getch();
				break;
			case 'N':
			case 'n':
				Ninput();
				break;
			case 'O':
			case 'o':
				output();
				break;
			case 'Z':
			case 'z':
				if(n>0){
					n--;
					Music[n][0]=0;
					Music[n][1]=0;
				}
				break;
			default:
				printf("Unknow Command\n");
				printf("Help --> Input: .H\n");
				getch();
				return 1;
				break;
		}
	}else{
		if( note=='S' || note=='s' || ( 'A'<=note && note<='G' ) || ( 'a'<=note && note<='g' ) )
			scanf("%d",&beat);
		switch(note){
			case '#':
				Tup=Tup==0?1:0;
				return 0;
				break;
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
				scale=note-'0'-1;
				return 0;
				break;
			case 'A'://
			case 'a':
				Music[n][0]=scale*12+(Tup==1?1:0)+0;
				break;
			case 'B':
			case 'b':
				Music[n][0]=scale*12+2;
				break;
			case 'C'://
			case 'c':
				if(scale==7 && Tup==1){
					printf("Sorry,the NoteLibrary is missing!\n");
					getch();
					return -1;
				}
				Music[n][0]=scale*12+(Tup==1?1:0)+3;
				break;
			case 'D'://
			case 'd':
				Music[n][0]=scale*12+(Tup==1?1:0)+5;
				break;
			case 'E':
			case 'e':
				if(scale==7){
					printf("Sorry,the NoteLibrary is missing!\n");
					getch();
					return -1;
				}
				Music[n][0]=scale*12+7;
				break;
			case 'F'://
			case 'f':
				if(scale==7){
					printf("Sorry,the NoteLibrary is missing!\n");
					getch();
					return -1;
				}
				Music[n][0]=scale*12+(Tup==1?1:0)+8;
				break;
			case 'G'://
			case 'g':
				if(scale==7){
					printf("Sorry,the NoteLibrary is missing!\n");
					getch();
					return -1;
				}
				Music[n][0]=scale*12+(Tup==1?1:0)+10;
				break;
			case 'S':
			case 's':
				Music[n][0]=0xFF;
				break;
			default:
				return 2;
				break;
		}
		if(beat<1 || beat>255){
			/*
			printf("The 'beat' is not good!\n");
			getch();
			*/
			return -1;
		}else Music[n][1]=beat;
		n++;
		if(n>=MAXMUSICLENG){
			printf("This project is too big!\n");
			getch();
			return -1;
		}
	}
	return 0;
}

int Ninput(){//-----6 ~ +++1 C=51
	char in;
	unsigned char note;
	int beat,temp=0,turn=0,restemp=0;
	printf("1=C: ");
	while(1){
		scanf("%c",&in);
		if('0'<=in && in<='7'){
			scanf("%d",&beat);
			if(beat<1 || beat>255){
				/*
				printf("The 'beat' is not good!\n");
				getch();
				*/
				return -1;
			}
		}
		switch(in){
			case 'U':
			case 'u':
				if(restemp<3){
					restemp++;
					temp=restemp;
				}
				break;
			case 'D':
			case 'd':
				if(restemp>-5){
					restemp--;
					temp=restemp;
				}
				break;
			case '+':
				if(temp<3) temp++;
				break;
			case '-':
				if(temp>-5) temp--;
				break;
			case '#':
				turn=1;
				break;
			case '.':
				return 0;
				break;
			case '0':
				Music[n][0]=0xFF;
				Music[n][1]=beat;
				n++;temp=restemp;turn=0;
				if(n>=MAXMUSICLENG){
					printf("This project is too big!\n");
					getch();
					return -1;
				}
				break;
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
				if((temp==-5 && in<6) || (temp==3 && in>1)){
					printf("Sorry,the NoteLibrary is missing!\n");
					getch();
					return -1;
				}
				switch(in){
					case '1'://
						Music[n][0]=51+temp*12+(turn==1?1:0)+0;
						break;
					case '2'://
						Music[n][0]=51+temp*12+(turn==1?1:0)+2;
						break;
					case '3':
						Music[n][0]=51+temp*12+4;
						break;
					case '4'://
						Music[n][0]=51+temp*12+(turn==1?1:0)+5;
						break;
					case '5'://
						Music[n][0]=51+temp*12+(turn==1?1:0)+7;
						break;
					case '6'://
						Music[n][0]=51+temp*12+(turn==1?1:0)+9;
						break;
					case '7':
						Music[n][0]=51+temp*12+11;
						break;
				}
				Music[n][1]=beat;
				n++;temp=restemp;turn=0;
				if(n>=MAXMUSICLENG){
					printf("This project is too big!\n");
					getch();
					return -1;
				}
				break;
			default:
				break;
		}
	}
	return 0;
}

int output(){
	char temp=0;int i;
	printf("LoadingOut...\n");
	while((temp=fgetc(headin))!=EOF){
		fputc(temp,fout);
	}
	fprintf(fout,NOTELIB);
	fprintf(fout,MUSICARRHEAD);
	for(i=0;i<n;i++){
		if(i!=0) fputc(',',fout);
		fprintf(fout,"{%d,%d}",Music[i][0],Music[i][1]);
	}fprintf(fout,",{0xFF,0}");fprintf(fout,ENDARR);
	fprintf(fout,MAXBEATCODE);fprintf(fout,"%d;\n",MAXBEAT);
	while((temp=fgetc(bodyin))!=EOF){
		fputc(temp,fout);
	}
	printf("Done!\n");
	printf("Please copy \"%s\" in the root of the program or copy follow:",OUTFILE);
	printf("\n\n");
	rewind(fout);
	while((temp=fgetc(fout))!=EOF){
		putchar(temp);
	}
	printf("\n\n");getch();
	rewind(headin);
	rewind(bodyin);
	rewind(fout);
	return 0;
}
